// test.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include "mtvp/mtvp.h"

#define MAX_LOADSTRING 100

/*--------------------------------------------------------------------------+
| Macros																	|
+--------------------------------------------------------------------------*/
/* for the msg.h package */
#define MSG_PTR (&Msg)

/*--------------------------------------------------------------------------+
| Globals																	|
+--------------------------------------------------------------------------*/

// Global Variables:
HINSTANCE hInst;								// current instance
HWND hWnd;
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

/* to communicate with player */
static MTVP_PLAYER	*Player;

/* for the msg.h package */
static MTVP_MSG_STRUCT Msg;

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_TEST, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_TEST);

	/*
	 * Start the player
	 */

	/*
	 * Set Msg.select == -1 to print all the warnings and messages.
	 * See msg.h for the MESSAGE() and WARNING() macros definitions.
	 */
	 
	Msg.select = -1;

	{
		static const char *mtvp_argv[] = {
			"",		/* first item ignored on win32, but should not be NULL */
//			"-w",	/* trace everything */
//			"-a0",	/* disable audio */
			NULL,	/* must be NULL-terminated */
		};
		int		status;
	
		if ((status = mtvp_create_player(&Player, mtvp_argv, NULL, (void *)hWnd)) != 0) {
			_msg_printf("cannot start player (%s)\n", mtvp_argv[0]);
			return -1;
		}
		mtvp_send_command_int(Player, MTVP_COMMAND_WINDOW_ID, 0, (int)hWnd);

//		mtvp_send_command_int(Player, MTVP_COMMAND_AUTO_PLAY, 0, False);
		mtvp_send_command_int(Player, MTVP_COMMAND_AUDIO_CHANNEL, 0, MTVP_AUDIO_CHANNEL_LEFT);
		mtvp_send_command_int(Player, MTVP_COMMAND_AUDIO_QUALITY, 0, MTVP_AUDIO_QUALITY_MEDIUM);
		mtvp_send_command_int(Player, MTVP_COMMAND_LOOP, 0, True);
		mtvp_send_command_string(Player, MTVP_COMMAND_OPEN_STREAM_URL, 0, "file:\\\\HOPKINS\\tristan\\mpg\\avseq04.mpg");
//		mtvp_send_command_string(Player, MTVP_COMMAND_OPEN_STREAM_URL, 0, "http://www.mpegtv.com/starwars.mpg");
//		mtvp_send_command_int(Player, MTVP_COMMAND_STATE, 0, MTVP_STATE_PLAYING);
	}

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) {
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_TEST);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_TEST;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			{
			RECT rt;
			GetClientRect(hWnd, &rt);
			DrawText(hdc, szHello, strlen(szHello), &rt, DT_CENTER);
			}
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			_msg_printf("sending MTVP_COMMAND_QUIT\n");
			if (Player != NULL) {
				mtvp_send_command_void(Player, MTVP_COMMAND_QUIT, 0);
				mtvp_destroy_player(Player);
				Player = NULL;
			}
			PostQuitMessage(0);
			break;
		default:
			{
				MTVP_PMP_HEADER	header;
				MTVP_PMP_DATA_A2G	data;

				if (Player != NULL && mtvp_translate_msg(Player, message, wParam, lParam, &header, &data) == 0) {
					_msg_printf("received message from player in window procedure\n");
					switch(header.type) {
					default:
						break;
					}
					return 0;
				} else {
					return DefWindowProc(hWnd, message, wParam, lParam);
				}
			}
   }
   return 0;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
